import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class Simulator implements Runnable
{
    private ScheduledExecutorService schedExecService; //realtime process
    private Fahrzeug fahrzeug;
    private Sensor sensor;
    private long DT;
    private iRegler regler;
    public Simulator(long DT, Fahrzeug fahrzeug, iRegler regler, Sensor sensor)
    {
         this.sensor = sensor;
         this.regler = regler;
         this.DT = DT;
         this.fahrzeug = fahrzeug;
         schedExecService = Executors.newSingleThreadScheduledExecutor();
         schedExecService.scheduleAtFixedRate(this, 0, DT, TimeUnit.MILLISECONDS);                   
    }
        
    public void run()
    {
         double x = fahrzeug.getX();
         double y = fahrzeug.getY();
         double phi = fahrzeug.getPhi();
         double v_antrieb = fahrzeug.getVantrieb();
         
         double dt = (double)DT*0.001;
         
         double vx = v_antrieb*Math.cos(phi);
         double vy = v_antrieb*Math.sin(phi);
         
         double x_neu = x + vx*dt;
         double y_neu = y + vy*dt;
         
         double regelabweichung = sensor.bestimmeRegelabweichung();
         double stellwert = regler.berechneStellwert(regelabweichung,dt);
println("regelabweichung = "+stellwert);         
         phi+=stellwert*dt;
         
         fahrzeug.setPosition(x_neu, y_neu,phi);         
    }
}